000100 IDENTIFICATION DIVISION.                                         POS00685
000200 PROGRAM-ID.    MATHPK.                                           SOBEMAP.
000300                                                                  SOBEMAP.
000400 AUTHOR.        LEIF SVALGAARD.                                   SOBEMAP.
000500 DATE-WRITTEN.  87/02/01                                          SOBEMAP.
000600     -REVISED:  93/08/20.                                         93/08/20
000700                                                                  SOBEMAP.
000800 ENVIRONMENT DIVISION.                                            SOBEMAP.
000900                                                                  SOBEMAP.
001000 CONFIGURATION SECTION.                                           SOBEMAP.
001100 SOURCE-COMPUTER. PORTABLE.                                       SOBEMAP.
001200 OBJECT-COMPUTER. PORTABLE.                                       SOBEMAP.
001300                                                                  SOBEMAP.
001400 DATA DIVISION.                                                   SOBEMAP.
001500                                                                  SOBEMAP.
001600 WORKING-STORAGE SECTION.                                         SOBEMAP.
001700                                                                  SOBEMAP.
001800 01  HIGH-PRECISION-CONSTANTS.                                    SOBEMAP.
001900     02  VALUE-ZERO              PIC S9(9)V9(9) COMP              90/09/20
002000                                              VALUE +0.000000000. 90/09/20
002100     02  VALUE-TEN               PIC S9(9)V9(9) COMP              87/05/29
002200                                              VALUE +10.00000000. 87/05/29
002300     02  SQRT-TEN                PIC S9(9)V9(9) COMP              87/05/29
002400                                              VALUE +3.162277660. 87/05/29
002500     02  SQRT-OF-5-POINT-5       PIC S9(9)V9(9) COMP              87/05/29
002600                                              VALUE +2.345207879. 87/05/29
002700     02  SQRT-OF-0-POINT-55      PIC S9(9)V9(9) COMP              87/05/29
002800                                              VALUE +0.741619848. 87/05/29
002900                                                                  87/05/29
003000     02  TWO-PI                  PIC S9(9)V9(9) COMP              87/05/29
003100                                              VALUE +6.283185307. 87/05/29
003200     02  VALUE-PI                PIC S9(3)V9(9) COMP              87/05/29
003300                                              VALUE +3.141592654. 87/05/29
003400     02  PI-HALF                 PIC S9(3)V9(9) COMP              87/05/29
003500                                              VALUE +1.570796327. 87/05/29
003600     02  PI-QUARTER              PIC S9(3)V9(9) COMP              SOBEMAP.
003700                                              VALUE +0.785398163. SOBEMAP.
003800                                                                  87/05/29
003900     02  ONE-HALF                PIC S9(3)V9(9) COMP              SOBEMAP.
004000                                              VALUE +0.500000000. SOBEMAP.
004100     02  VALUE-ONE               PIC S9(3)V9(9) COMP              87/05/29
004200                                              VALUE +1.000000000. 87/05/29
004300     02  VALUE-TWO               PIC S9(3)V9(9) COMP              87/05/29
004400                                              VALUE +2.000000000. 87/05/29
004500     02  SQRT-TWO                PIC S9(3)V9(9) COMP              SOBEMAP.
004600                                              VALUE +1.414213562. SOBEMAP.
004700     02  LOG2-OF-TEN             PIC S9(3)V9(9) COMP              SOBEMAP.
004800                                              VALUE +3.321928096. SOBEMAP.
004900     02  TOP-LOGARITHM           PIC S9(3)V9(9) COMP              SOBEMAP.
005000                                              VALUE +8.999999999. SOBEMAP.
005100                                                                  87/06/10
005200     02  VALUE-E                 PIC S9(3)V9(9) COMP              SOBEMAP.
005300                                              VALUE +2.718281828. SOBEMAP.
005400     02  VALUE-GOLDEN-RATIO      PIC S9(3)V9(9) COMP              SOBEMAP.
005500                                              VALUE +1.618033989. SOBEMAP.
005600                                                                  87/06/10
005700 01  COEFFICIENTS.                                                SOBEMAP.
005800     02  FOR-LOGS.                                                SOBEMAP.
005900         03  LOG-COEFF1          PIC S9(3)V9(9) COMP              SOBEMAP.
006000                                              VALUE +2.885390073. SOBEMAP.
006100         03  LOG-COEFF3          PIC S9(3)V9(9) COMP              SOBEMAP.
006200                                              VALUE +0.961800762. SOBEMAP.
006300         03  LOG-COEFF5          PIC S9(3)V9(9) COMP              SOBEMAP.
006400                                              VALUE +0.576584342. SOBEMAP.
006500         03  LOG-COEFF7          PIC S9(3)V9(9) COMP              SOBEMAP.
006600                                              VALUE +0.434259751. SOBEMAP.
006700                                                                  SOBEMAP.
006800     02  FOR-ANTILOGS.                                            SOBEMAP.
006900         03  ALOG-KOEFF1         PIC S9(3)V9(9) COMP              SOBEMAP.
007000                                              VALUE +1.151292776. SOBEMAP.
007100         03  ALOG-KOEFF2         PIC S9(3)V9(9) COMP              SOBEMAP.
007200                                              VALUE +0.662730884. SOBEMAP.
007300         03  ALOG-KOEFF3         PIC S9(3)V9(9) COMP              SOBEMAP.
007400                                              VALUE +0.254393575. SOBEMAP.
007500         03  ALOG-KOEFF4         PIC S9(3)V9(9) COMP              SOBEMAP.
007600                                              VALUE +0.072951737. SOBEMAP.
007700         03  ALOG-KOEFF5         PIC S9(3)V9(9) COMP              SOBEMAP.
007800                                              VALUE +0.017421120. SOBEMAP.
007900         03  ALOG-KOEFF6         PIC S9(3)V9(9) COMP              SOBEMAP.
008000                                              VALUE +0.002554918. SOBEMAP.
008100         03  ALOG-KOEFF7         PIC S9(3)V9(9) COMP              SOBEMAP.
008200                                              VALUE +0.000932643. SOBEMAP.
008300                                                                  SOBEMAP.
008400     02  FOR-ARCTAN.                                              SOBEMAP.
008500         03  ATAN-COEFF1         PIC S9(3)V9(9) COMP              SOBEMAP.
008600                                              VALUE +0.999999333. SOBEMAP.
008700         03  ATAN-COEFF3         PIC S9(3)V9(9) COMP              SOBEMAP.
008800                                              VALUE -0.333298561. SOBEMAP.
008900         03  ATAN-COEFF5         PIC S9(3)V9(9) COMP              SOBEMAP.
009000                                              VALUE +0.199465360. SOBEMAP.
009100         03  ATAN-COEFF7         PIC S9(3)V9(9) COMP              SOBEMAP.
009200                                              VALUE -0.139085335. SOBEMAP.
009300         03  ATAN-COEFF9         PIC S9(3)V9(9) COMP              SOBEMAP.
009400                                              VALUE +0.096420044. SOBEMAP.
009500         03  ATAN-COEFF11        PIC S9(3)V9(9) COMP              SOBEMAP.
009600                                              VALUE -0.055909886. SOBEMAP.
009700         03  ATAN-COEFF13        PIC S9(3)V9(9) COMP              SOBEMAP.
009800                                              VALUE +0.021861229. SOBEMAP.
009900         03  ATAN-COEFF15        PIC S9(3)V9(9) COMP              SOBEMAP.
010000                                              VALUE -0.004054058. SOBEMAP.
010100                                                                  SOBEMAP.
010200     02  FOR-SINE.                                                87/05/29
010300         03  SINE-COEFF1         PIC S9(3)V9(9) COMP              87/05/29
010400                                              VALUE +1.570796318. 87/05/29
010500         03  SINE-COEFF3         PIC S9(3)V9(9) COMP              87/05/29
010600                                              VALUE -0.645963711. 87/05/29
010700         03  SINE-COEFF5         PIC S9(3)V9(9) COMP              87/05/29
010800                                              VALUE +0.079689679. 87/05/29
010900         03  SINE-COEFF7         PIC S9(3)V9(9) COMP              87/05/29
011000                                              VALUE -0.004673766. 87/05/29
011100         03  SINE-COEFF9         PIC S9(3)V9(9) COMP              87/05/29
011200                                              VALUE +0.000151484. 87/05/29
011300                                                                  87/06/10
011400     02  FOR-ARCSIN.                                              87/05/30
011500         03  ARCSIN-COEFF0       PIC S9(3)V9(9) COMP              87/05/30
011600                                              VALUE +1.570796305. 87/05/30
011700         03  ARCSIN-COEFF1       PIC S9(3)V9(9) COMP              87/05/30
011800                                              VALUE -0.214598802. 87/05/30
011900         03  ARCSIN-COEFF2       PIC S9(3)V9(9) COMP              87/05/30
012000                                              VALUE +0.088978987. 87/05/30
012100         03  ARCSIN-COEFF3       PIC S9(3)V9(9) COMP              87/05/30
012200                                              VALUE -0.050174305. 87/05/30
012300         03  ARCSIN-COEFF4       PIC S9(3)V9(9) COMP              87/05/30
012400                                              VALUE +0.030891881. 87/05/30
012500         03  ARCSIN-COEFF5       PIC S9(3)V9(9) COMP              87/05/30
012600                                              VALUE -0.017088126. 87/05/30
012700         03  ARCSIN-COEFF6       PIC S9(3)V9(9) COMP              87/05/30
012800                                              VALUE +0.006670090. 87/05/30
012900         03  ARCSIN-COEFF7       PIC S9(3)V9(9) COMP              87/05/30
013000                                              VALUE -0.001262491. 87/05/30
013100                                                                  87/06/10
013200     02  FOR-EXPONENTIAL.                                         87/05/30
013300         03  EXP-COEFF1          PIC S9(3)V9(9) COMP              87/05/30
013400                                              VALUE +0.249998684. 87/05/30
013500         03  EXP-COEFF2          PIC S9(3)V9(9) COMP              87/05/30
013600                                              VALUE +0.031257583. 87/05/30
013700         03  EXP-COEFF3          PIC S9(3)V9(9) COMP              87/05/30
013800                                              VALUE +0.002591371. 87/05/30
013900         03  EXP-COEFF4          PIC S9(3)V9(9) COMP              87/05/30
014000                                              VALUE +0.000171562. 87/05/30
014100         03  EXP-COEFF5          PIC S9(3)V9(9) COMP              87/05/30
014200                                              VALUE +0.000005430. 87/05/30
014300         03  EXP-COEFF6          PIC S9(3)V9(9) COMP              87/05/30
014400                                              VALUE +0.000000691. 87/05/30
014500                                                                  87/05/30
014600 01  BEGIN-DYNAMIC-STORAGE       PIC X(4)   VALUE "<ETK".         SOBEMAP.
014700                                                                  SOBEMAP.
014800 01  HIGH-PRECISION-VARIABLES.                                    87/05/29
014900     02  MAX-VALUE-X             PIC S9(9)V9(9) COMP              SOBEMAP.
015000                                              VALUE +999999999.   SOBEMAP.
015100     02  EXP-X                   PIC S9(9)V9(9) COMP VALUE ZERO.  87/05/29
015200     02  SQRT-X                  PIC S9(9)V9(9) COMP VALUE ZERO.  87/05/29
015300     02  ITERATED-ARG            PIC S9(9)V9(9) COMP VALUE ZERO.  87/05/29
015400     02  ARG-LIMIT               PIC S9(9)V9(9) COMP VALUE ZERO.  87/05/29
015500     02  ARG-X                   PIC S9(9)V9(9) COMP VALUE ZERO.  87/05/29
015600     02  EXPONENT-P              PIC S9(9)V9(9) COMP VALUE ZERO.  SOBEMAP.
015700     02  ANTILOG-X               PIC S9(9)V9(9) COMP VALUE ZERO.  SOBEMAP.
015800     02  TRANSF--W               PIC S9(3)V9(9) COMP VALUE ZERO.  93/08/20
015900     02  TRANSF--X               PIC S9(3)V9(9) COMP VALUE ZERO.  93/08/20
016000     02  TRANSF-XX               PIC S9(3)V9(9) COMP VALUE ZERO.  SOBEMAP.
016100     02  CHARACTERISTIC-X        PIC S9(3)V9(9) COMP VALUE ZERO.  SOBEMAP.
016200     02  MANTISSA-X              PIC S9(3)V9(9) COMP VALUE ZERO.  SOBEMAP.
016300     02  LOGARITHM-X             PIC S9(3)V9(9) COMP VALUE ZERO.  SOBEMAP.
016400     02  ARCTAN-X                PIC S9(3)V9(9) COMP VALUE ZERO.  SOBEMAP.
016500     02  X1                      PIC S9(3)V9(9) COMP VALUE ZERO.  87/05/29
016600     02  X2                      PIC S9(3)V9(9) COMP VALUE ZERO.  87/05/29
016700     02  FRACTIONAL-TURN         PIC S9(3)V9(9) COMP VALUE ZERO.  87/05/29
016800     02  SINE-X                  PIC S9(3)V9(9) COMP VALUE ZERO.  87/05/29
016900     02  ARCSIN-X                PIC S9(3)V9(9) COMP VALUE ZERO.  87/05/30
017000     02  WORK-X                  PIC S9(9)V9(9) COMP VALUE ZERO.  SOBEMAP.
017100     02  WORK-W                  PIC S9(9)V9(9) COMP VALUE ZERO.  93/08/20
017200                                                                  87/06/10
017300 01  RANDOM-VARIABLES.                                            87/06/10
017400     02  RANDOM-PRECISION        PIC S9(7)  COMP  VALUE +9999999. 87/06/10
017500     02  RANDOM-INTEGER          PIC S9(7)  COMP  VALUE   ZERO.   87/06/10
017600     02  RANDOM-MODULUS          PIC S9(7)  COMP  VALUE +2099863. 87/06/10
017700     02  RANDOM-MULTIPLIER       PIC S9(7)  COMP  VALUE +1005973. 87/06/10
017800     02  RANDOM-INCREMENT        PIC S9(7)  COMP  VALUE  +443771. 87/06/10
017900     02  RANDOM-QUOTIENT         PIC S9(7)  COMP  VALUE   ZERO.   87/06/10
018000     02  RANDOM-PRODUCT          PIC S9(15) COMP  VALUE   ZERO.   87/06/10
018100     02  RANDOM-ADJUST           PIC S9(9)  COMP  VALUE +2099863. 87/06/10
018200                                                                  87/06/10
018300 01  VARIOUS-INDICATORS.                                          87/05/29
018400     02  SIGN-OF-ARGUMENT        PIC X.                           87/05/29
018500         88  ARGUMENT-IS-POSITIVE           VALUE IS "P".         87/05/29
018600         88  ARGUMENT-IS-ZERO               VALUE IS "Z".         87/05/29
018700         88  ARGUMENT-IS-NEGATIVE           VALUE IS "N".         87/05/29
018800                                                                  87/05/29
018900     02  SIGN-OF-RESULT          PIC X.                           87/05/29
019000         88  RESULT-IS-POSITIVE             VALUE IS "P".         87/05/29
019100         88  RESULT-IS-ZERO                 VALUE IS "Z".         87/05/29
019200         88  RESULT-IS-NEGATIVE             VALUE IS "N".         87/05/29
019300                                                                  87/05/29
019400     02  NUMBER-OF-TURNS         PIC  9(9)V9(9) DISPLAY.          87/05/29
019500     02  FILLER                  REDEFINES  NUMBER-OF-TURNS.      87/05/29
019600         03  WHOLE-TURNS         PIC  9(9).                       87/05/29
019700         03  FILLER              PIC  9(9).                       87/05/29
019800                                                                  87/05/29
019900     02  SIGN-OF-LOGARITHM       PIC X.                           SOBEMAP.
020000         88  LOG-IS-POSITIVE                VALUE IS "P".         SOBEMAP.
020100         88  LOG-IS-NEGATIVE                VALUE IS "N".         SOBEMAP.
020200                                                                  87/05/27
020300 LINKAGE SECTION.                                                 SOBEMAP.
020400                                                                  SOBEMAP.
020500 01  MATHPK-CONTROL.                                              SOBEMAP.
020600     02  SESSION-TASK-ID         PIC X(4).                        SOBEMAP.
020700     02  MATHPK-OPERATION        PIC X(8).                        SOBEMAP.
020800     02  MATHPK-FEEDBACK         PIC X.                           SOBEMAP.
020900         88  MATHPK-DOMAIN-ERROR            VALUE IS "D".         SOBEMAP.
021000         88  MATHPK-RANGE-ERROR             VALUE IS "R".         SOBEMAP.
021100                                                                  SOBEMAP.
021200     02  MATHPK-RESULT           PIC S9(9)V9(9) COMP.             SOBEMAP.
021300     02  MATHPK-ARGUMENT-1       PIC S9(9)V9(9) COMP.             SOBEMAP.
021400     02  MATHPK-ARGUMENT-2       PIC S9(9)V9(9) COMP.             SOBEMAP.
021500                                                                  SOBEMAP.
021600 PROCEDURE DIVISION                                               SOBEMAP.
021700     USING MATHPK-CONTROL.                                        SOBEMAP.
021800                                                                  SOBEMAP.
021900 BEGIN-OF-PACKAGE.                                                SOBEMAP.
022000     MOVE SPACE TO MATHPK-FEEDBACK                                SOBEMAP.
022100                                                                  SOBEMAP.
022200     IF MATHPK-OPERATION = "SQRT"                                 SOBEMAP.
022300         PERFORM SQRT-FUNCTION                                    SOBEMAP.
022400     ELSE                                                         SOBEMAP.
022500     IF MATHPK-OPERATION = "POWER"                                SOBEMAP.
022600         PERFORM POWER-FUNCTION                                   SOBEMAP.
022700     ELSE                                                         SOBEMAP.
022800     IF MATHPK-OPERATION = "LOG10"                                SOBEMAP.
022900         PERFORM LOGARITHM-10-FUNCTION                            SOBEMAP.
023000     ELSE                                                         SOBEMAP.
023100     IF MATHPK-OPERATION = "ALOG10"                               SOBEMAP.
023200         PERFORM ANTILOG-10-FUNCTION                              SOBEMAP.
023300     ELSE                                                         SOBEMAP.
023400     IF MATHPK-OPERATION = "ARCTAN"                               SOBEMAP.
023500         PERFORM ARCTAN-FUNCTION                                  SOBEMAP.
023600     ELSE                                                         SOBEMAP.
023700     IF MATHPK-OPERATION = "SIN"                                  SOBEMAP.
023800         PERFORM SINE-FUNCTION                                    SOBEMAP.
023900     ELSE                                                         SOBEMAP.
024000     IF MATHPK-OPERATION = "COS"                                  SOBEMAP.
024100         PERFORM COSINE-FUNCTION                                  SOBEMAP.
024200     ELSE                                                         SOBEMAP.
024300     IF MATHPK-OPERATION = "ARCSIN"                               SOBEMAP.
024400         PERFORM ARCSINE-FUNCTION                                 SOBEMAP.
024500     ELSE                                                         SOBEMAP.
024600     IF MATHPK-OPERATION = "EXP"                                  SOBEMAP.
024700         PERFORM EXPONENTIAL-FUNCTION                             SOBEMAP.
024800     ELSE                                                         SOBEMAP.
024900     IF MATHPK-OPERATION = "RANDOM"                               SOBEMAP.
025000         PERFORM RANDOM-FUNCTION                                  SOBEMAP.
025100     ELSE                                                         SOBEMAP.
025200     IF MATHPK-OPERATION = "SEEDRAND"                             SOBEMAP.
025300         PERFORM SEED-RANDOM-FUNCTION                             SOBEMAP.
025400     ELSE                                                         SOBEMAP.
025500     IF MATHPK-OPERATION = "E"                                    SOBEMAP.
025600         PERFORM RETURN-VALUE-OF-E                                SOBEMAP.
025700     ELSE                                                         SOBEMAP.
025800     IF MATHPK-OPERATION = "PI"                                   SOBEMAP.
025900         PERFORM RETURN-VALUE-OF-PI                               SOBEMAP.
026000     ELSE                                                         SOBEMAP.
026100     IF MATHPK-OPERATION = "GOLDEN"                               SOBEMAP.
026200         PERFORM RETURN-VALUE-OF-GOLDEN-RATIO                     SOBEMAP.
026300     ELSE                                                         SOBEMAP.
026400         MOVE "OP ERROR" TO MATHPK-FEEDBACK                       SOBEMAP.
026500     .                                                            SOBEMAP.
026600 RETURN-TO-CALLER.                                                SOBEMAP.
026700     EXIT PROGRAM                                                 SOBEMAP.
026800     .                                                            SOBEMAP.
026900                                                                  SOBEMAP.
027000***********************    SQUARE ROOT    ************************87/05/29
027100*                                                                *SOBEMAP.
027200*               COMPUTES RESULT = SQRT (ARGUMENT-1)              *SOBEMAP.
027300*                                                                *SOBEMAP.
027400*----------------------------------------------------------------*SOBEMAP.
027500                                                                  87/05/29
027600 SQRT-FUNCTION.                                                   87/05/29
027700     MOVE MATHPK-ARGUMENT-1 TO ARG-X                              87/05/30
027800     PERFORM COMPUTE-SQRT-FUNCTION                                87/05/29
027900     MOVE SQRT-X TO MATHPK-RESULT                                 87/06/10
028000     .                                                            87/05/29
028100                                                                  87/05/29
028200 COMPUTE-SQRT-FUNCTION.                                           87/05/29
028300     IF ARG-X > ZERO                                              87/05/29
028400         PERFORM COMPUTE-SQRT-APPROX                              87/05/29
028500     ELSE                                                         87/05/29
028600     IF ARG-X < ZERO                                              87/05/29
028700         PERFORM SET-DOMAIN-ERROR                                 87/05/30
028800     ELSE                                                         87/05/29
028900         MOVE ZERO TO SQRT-X                                      87/05/29
029000     .                                                            87/05/29
029100                                                                  87/05/29
029200 COMPUTE-SQRT-APPROX.                                             87/05/29
029300     MOVE VALUE-ONE TO ITERATED-ARG                               87/05/29
029400     IF ARG-X > VALUE-ONE                                         87/05/29
029500         COMPUTE ARG-LIMIT = ARG-X / 10                           87/05/29
029600         MOVE SQRT-OF-5-POINT-5 TO SQRT-X                         87/05/29
029700         PERFORM INCREASE-ARG-AND-ROOT                            87/05/29
029800           UNTIL ITERATED-ARG > ARG-LIMIT                         87/05/29
029900         PERFORM NEWTON-ITERATION 5 TIMES                         87/05/29
030000     ELSE                                                         87/05/29
030100     IF ARG-X < VALUE-ONE                                         87/05/29
030200         COMPUTE ARG-LIMIT = ARG-X * 10                           87/05/29
030300         MOVE SQRT-OF-0-POINT-55 TO SQRT-X                        87/05/29
030400         PERFORM DECREASE-ARG-AND-ROOT                            87/05/29
030500           UNTIL ITERATED-ARG < ARG-LIMIT                         87/05/29
030600         PERFORM NEWTON-ITERATION 5 TIMES                         87/05/29
030700     ELSE                                                         87/05/29
030800         MOVE VALUE-ONE TO SQRT-X                                 87/05/29
030900     .                                                            87/05/29
031000                                                                  87/05/29
031100 INCREASE-ARG-AND-ROOT.                                           87/05/29
031200     COMPUTE ITERATED-ARG = ITERATED-ARG * VALUE-TEN              87/05/29
031300     COMPUTE SQRT-X = SQRT-X * SQRT-TEN                           87/05/29
031400     .                                                            87/05/29
031500                                                                  87/05/29
031600 DECREASE-ARG-AND-ROOT.                                           87/05/29
031700     COMPUTE ITERATED-ARG = ITERATED-ARG / VALUE-TEN              87/05/29
031800     COMPUTE SQRT-X = SQRT-X / SQRT-TEN                           87/05/29
031900     .                                                            87/05/29
032000                                                                  87/05/29
032100 NEWTON-ITERATION.                                                87/05/29
032200     COMPUTE SQRT-X = (ARG-X / SQRT-X + SQRT-X) / VALUE-TWO       87/05/29
032300     .                                                            87/05/29
032400                                                                  87/05/29
032500 SET-DOMAIN-ERROR.                                                87/06/10
032600     MOVE "DOMAIN ERROR" TO MATHPK-FEEDBACK                       SOBEMAP.
032700     .                                                            87/06/10
032800                                                                  87/06/10
032900********************     POWER FUNCTION     **********************SOBEMAP.
033000*                                                                *SOBEMAP.
033100*           COMPUTES RESULT = ARGUMENT-1 ** ARGUMENT-2           *SOBEMAP.
033200*                                                                *SOBEMAP.
033300*----------------------------------------------------------------*SOBEMAP.
033400                                                                  SOBEMAP.
033500 POWER-FUNCTION.                                                  SOBEMAP.
033600     MOVE MATHPK-ARGUMENT-1 TO WORK-X                             SOBEMAP.
033700     MOVE MATHPK-ARGUMENT-2 TO EXPONENT-P                         SOBEMAP.
033800                                                                  SOBEMAP.
033900     IF EXPONENT-P = ZERO                                         SOBEMAP.
034000         MOVE VALUE-ONE TO MATHPK-RESULT                          SOBEMAP.
034100     ELSE                                                         SOBEMAP.
034200         IF WORK-X = ZERO                                         SOBEMAP.
034300             IF EXPONENT-P > ZERO                                 SOBEMAP.
034400                 MOVE ZERO TO MATHPK-RESULT                       SOBEMAP.
034500             ELSE                                                 SOBEMAP.
034600                 PERFORM SET-DOMAIN-ERROR                         87/06/10
034700         ELSE                                                     SOBEMAP.
034800         IF WORK-X > ZERO                                         SOBEMAP.
034900             PERFORM COMPUTE-POWER-FUNCTION                       SOBEMAP.
035000         ELSE                                                     SOBEMAP.
035100             PERFORM SET-DOMAIN-ERROR                             87/06/10
035200     .                                                            SOBEMAP.
035300                                                                  SOBEMAP.
035400 COMPUTE-POWER-FUNCTION.                                          SOBEMAP.
035500     PERFORM COMPUTE-LOGARITHM-FUNCTION                           SOBEMAP.
035600     COMPUTE WORK-X ROUNDED = EXPONENT-P * LOGARITHM-X            SOBEMAP.
035700                                                                  SOBEMAP.
035800     IF WORK-X < TOP-LOGARITHM                                    SOBEMAP.
035900         PERFORM COMPUTE-ANTILOG-FUNCTION                         SOBEMAP.
036000         MOVE  ANTILOG-X  TO MATHPK-RESULT                        SOBEMAP.
036100     ELSE                                                         SOBEMAP.
036200         PERFORM SET-RANGE-ERROR                                  87/06/10
036300     .                                                            SOBEMAP.
036400                                                                  SOBEMAP.
036500 SET-RANGE-ERROR.                                                 87/06/10
036600     MOVE "RANGE ERROR" TO MATHPK-FEEDBACK                        SOBEMAP.
036700     .                                                            87/06/10
036800                                                                  87/06/10
036900******************    LOGARITHM 10 FUNCTION    *******************SOBEMAP.
037000*                                                                *SOBEMAP.
037100*              COMPUTES RESULT = LOG10 (ARGUMENT-1)              *SOBEMAP.
037200*                                                                *SOBEMAP.
037300*----------------------------------------------------------------*SOBEMAP.
037400                                                                  SOBEMAP.
037500 LOGARITHM-10-FUNCTION.                                           SOBEMAP.
037600     MOVE MATHPK-ARGUMENT-1 TO WORK-X                             SOBEMAP.
037700                                                                  SOBEMAP.
037800     IF WORK-X > ZERO                                             SOBEMAP.
037900         PERFORM COMPUTE-LOGARITHM-FUNCTION                       SOBEMAP.
038000         MOVE LOGARITHM-X TO MATHPK-RESULT                        SOBEMAP.
038100     ELSE                                                         SOBEMAP.
038200         PERFORM SET-DOMAIN-ERROR                                 87/06/10
038300     .                                                            SOBEMAP.
038400                                                                  SOBEMAP.
038500 COMPUTE-LOGARITHM-FUNCTION.                                      SOBEMAP.
038600     IF WORK-X < VALUE-ONE                                        SOBEMAP.
038700         MOVE "NEG" TO SIGN-OF-LOGARITHM                          SOBEMAP.
038800         COMPUTE WORK-X = VALUE-ONE / WORK-X                      SOBEMAP.
038900     ELSE                                                         SOBEMAP.
039000         MOVE "POS" TO SIGN-OF-LOGARITHM                          SOBEMAP.
039100     .                                                            SOBEMAP.
039200     PERFORM REDUCE-X-TO-INTERVAL--1-TO-2                         SOBEMAP.
039300     PERFORM RATIONAL-LOG-TRANSFORMATION                          SOBEMAP.
039400     PERFORM EVALUATE-LOGARITHM-APPROX                            SOBEMAP.
039500                                                                  SOBEMAP.
039600     IF LOG-IS-NEGATIVE                                           SOBEMAP.
039700         COMPUTE LOGARITHM-X = VALUE-ZERO - LOGARITHM-X           90/09/20
039800     .                                                            SOBEMAP.
039900                                                                  SOBEMAP.
040000 REDUCE-X-TO-INTERVAL--1-TO-2.                                    SOBEMAP.
040100     MOVE ZERO TO CHARACTERISTIC-X                                SOBEMAP.
040200     PERFORM DIVIDE-BY-TWO                                        SOBEMAP.
040300       UNTIL WORK-X < VALUE-TWO                                   SOBEMAP.
040400     .                                                            SOBEMAP.
040500                                                                  SOBEMAP.
040600 DIVIDE-BY-TWO.                                                   SOBEMAP.
040700     COMPUTE WORK-X = WORK-X / VALUE-TWO                          SOBEMAP.
040800     ADD VALUE-ONE TO CHARACTERISTIC-X                            SOBEMAP.
040900     .                                                            SOBEMAP.
041000                                                                  SOBEMAP.
041100 RATIONAL-LOG-TRANSFORMATION.                                     SOBEMAP.
041200     COMPUTE TRANSF--X = (WORK-X - SQRT-TWO)                      SOBEMAP.
041300                       / (WORK-X + SQRT-TWO)                      SOBEMAP.
041400     COMPUTE TRANSF-XX = TRANSF--X * TRANSF--X                    SOBEMAP.
041500     .                                                            SOBEMAP.
041600                                                                  SOBEMAP.
041700 EVALUATE-LOGARITHM-APPROX.                                       SOBEMAP.
041800     COMPUTE MANTISSA-X = ONE-HALF + TRANSF--X * (LOG-COEFF1      SOBEMAP.
041900                                   + TRANSF-XX * (LOG-COEFF3      SOBEMAP.
042000                                   + TRANSF-XX * (LOG-COEFF5      SOBEMAP.
042100                                   + TRANSF-XX *  LOG-COEFF7      SOBEMAP.
042200                                                         )))      87/05/27
042300     COMPUTE LOGARITHM-X ROUNDED = (MANTISSA-X + CHARACTERISTIC-X)SOBEMAP.
042400                                         / LOG2-OF-TEN            SOBEMAP.
042500     .                                                            SOBEMAP.
042600                                                                  SOBEMAP.
042700*******************    ANTILOG 10 FUNCTION    ********************SOBEMAP.
042800*                                                                *SOBEMAP.
042900*            COMPUTES RESULT = ANTILOG10 (ARGUMENT-1)            *SOBEMAP.
043000*                                                                *SOBEMAP.
043100*----------------------------------------------------------------*SOBEMAP.
043200                                                                  SOBEMAP.
043300 ANTILOG-10-FUNCTION.                                             SOBEMAP.
043400     MOVE MATHPK-ARGUMENT-1 TO WORK-X                             SOBEMAP.
043500     PERFORM COMPUTE-ANTILOG-FUNCTION                             SOBEMAP.
043600     MOVE ANTILOG-X TO MATHPK-RESULT                              SOBEMAP.
043700     .                                                            SOBEMAP.
043800                                                                  SOBEMAP.
043900 COMPUTE-ANTILOG-FUNCTION.                                        SOBEMAP.
044000     IF WORK-X < ZERO                                             SOBEMAP.
044100         MOVE "NEG" TO SIGN-OF-LOGARITHM                          SOBEMAP.
044200         COMPUTE TRANSF--X = VALUE-ZERO - WORK-X                  90/09/20
044300     ELSE                                                         SOBEMAP.
044400         MOVE "POS" TO SIGN-OF-LOGARITHM                          SOBEMAP.
044500         COMPUTE TRANSF--X =   WORK-X                             SOBEMAP.
044600     .                                                            SOBEMAP.
044700     IF TRANSF--X < TOP-LOGARITHM                                 SOBEMAP.
044800         PERFORM COMPUTE-RESULT-IN-RANGE                          SOBEMAP.
044900     ELSE                                                         SOBEMAP.
045000         PERFORM SET-RANGE-ERROR                                  87/06/10
045100     .                                                            SOBEMAP.
045200                                                                  SOBEMAP.
045300 COMPUTE-RESULT-IN-RANGE.                                         SOBEMAP.
045400     MOVE ZERO TO CHARACTERISTIC-X                                SOBEMAP.
045500     PERFORM SUBTRACT-ONE                                         SOBEMAP.
045600       UNTIL TRANSF--X < VALUE-ONE                                SOBEMAP.
045700                                                                  SOBEMAP.
045800     PERFORM EVALUATE-ANTILOG-APPROX                              SOBEMAP.
045900     MOVE TRANSF-XX TO WORK-X                                     SOBEMAP.
046000                                                                  SOBEMAP.
046100     PERFORM MULTIPLY-BY-TEN                                      SOBEMAP.
046200       UNTIL CHARACTERISTIC-X < VALUE-ONE                         SOBEMAP.
046300                                                                  SOBEMAP.
046400     IF LOG-IS-NEGATIVE                                           SOBEMAP.
046500         COMPUTE ANTILOG-X ROUNDED = VALUE-ONE / WORK-X           SOBEMAP.
046600     ELSE                                                         SOBEMAP.
046700         COMPUTE ANTILOG-X ROUNDED = WORK-X                       SOBEMAP.
046800     .                                                            SOBEMAP.
046900                                                                  SOBEMAP.
047000 SUBTRACT-ONE.                                                    SOBEMAP.
047100     SUBTRACT VALUE-ONE FROM TRANSF--X                            SOBEMAP.
047200     ADD      VALUE-ONE TO   CHARACTERISTIC-X                     SOBEMAP.
047300     .                                                            SOBEMAP.
047400                                                                  SOBEMAP.
047500 EVALUATE-ANTILOG-APPROX.                                         SOBEMAP.
047600     COMPUTE TRANSF--W =             TRANSF--X * (ALOG-KOEFF5     93/08/20
047700                                   + TRANSF--X * (ALOG-KOEFF6     93/08/20
047800                                   + TRANSF--X *  ALOG-KOEFF7))   93/08/20
047900     COMPUTE TRANSF--X = VALUE-ONE + TRANSF--X * (ALOG-KOEFF1     SOBEMAP.
048000                                   + TRANSF--X * (ALOG-KOEFF2     SOBEMAP.
048100                                   + TRANSF--X * (ALOG-KOEFF3     SOBEMAP.
048200                                   + TRANSF--X * (ALOG-KOEFF4     SOBEMAP.
048300                                   + TRANSF--W))))                93/08/20
048400     COMPUTE TRANSF-XX ROUNDED = TRANSF--X * TRANSF--X            SOBEMAP.
048500     .                                                            SOBEMAP.
048600                                                                  SOBEMAP.
048700 MULTIPLY-BY-TEN.                                                 SOBEMAP.
048800     COMPUTE WORK-X = WORK-X * VALUE-TEN                          SOBEMAP.
048900     SUBTRACT VALUE-ONE FROM CHARACTERISTIC-X                     SOBEMAP.
049000     .                                                            SOBEMAP.
049100                                                                  SOBEMAP.
049200*********************    ARCTAN FUNCTION    **********************SOBEMAP.
049300*                                                                *SOBEMAP.
049400*              COMPUTES RESULT = ARCTAN (ARGUMENT-1)             *SOBEMAP.
049500*                                                                *SOBEMAP.
049600*----------------------------------------------------------------*SOBEMAP.
049700                                                                  SOBEMAP.
049800 ARCTAN-FUNCTION.                                                 SOBEMAP.
049900     MOVE MATHPK-ARGUMENT-1 TO WORK-X                             SOBEMAP.
050000     PERFORM COMPUTE-ARCTAN-FUNCTION                              SOBEMAP.
050100     MOVE ARCTAN-X TO MATHPK-RESULT                               SOBEMAP.
050200     .                                                            SOBEMAP.
050300                                                                  SOBEMAP.
050400 COMPUTE-ARCTAN-FUNCTION.                                         SOBEMAP.
050500     IF WORK-X < ZERO                                             87/05/27
050600         COMPUTE WORK-X = VALUE-ZERO - WORK-X                     90/09/20
050700         MOVE "NEG" TO SIGN-OF-ARGUMENT                           87/05/27
050800         PERFORM COMPUTE-ARCTAN-APPROX                            87/05/27
050900     ELSE                                                         87/05/27
051000     IF WORK-X > ZERO                                             87/05/27
051100         MOVE "POS" TO SIGN-OF-ARGUMENT                           87/05/27
051200         PERFORM COMPUTE-ARCTAN-APPROX                            87/05/27
051300     ELSE                                                         87/05/27
051400         MOVE ZERO  TO ARCTAN-X                                   87/05/27
051500     .                                                            87/05/27
051600                                                                  87/05/27
051700 COMPUTE-ARCTAN-APPROX.                                           87/05/27
051800     PERFORM RATIONAL-TAN-TRANSFORMATION                          SOBEMAP.
051900     PERFORM EVALUATE-ARCTAN-APPROX                               SOBEMAP.
052000     IF ARGUMENT-IS-NEGATIVE                                      87/05/27
052100         COMPUTE ARCTAN-X = VALUE-ZERO - ARCTAN-X                 90/09/20
052200     .                                                            87/05/27
052300                                                                  SOBEMAP.
052400 RATIONAL-TAN-TRANSFORMATION.                                     SOBEMAP.
052500     COMPUTE TRANSF--X = (WORK-X - VALUE-ONE)                     SOBEMAP.
052600                       / (WORK-X + VALUE-ONE)                     SOBEMAP.
052700     COMPUTE TRANSF-XX = TRANSF--X * TRANSF--X                    SOBEMAP.
052800     .                                                            SOBEMAP.
052900                                                                  SOBEMAP.
053000 EVALUATE-ARCTAN-APPROX.                                          SOBEMAP.
053100     COMPUTE WORK-W = TRANSF-XX * (ATAN-COEFF9                    93/08/20
053200                    + TRANSF-XX * (ATAN-COEFF11                   93/08/20
053300                    + TRANSF-XX * (ATAN-COEFF13                   93/08/20
053400                    + TRANSF-XX *  ATAN-COEFF15)))                93/08/20
053500     COMPUTE WORK-X = TRANSF--X * (ATAN-COEFF1                    93/08/20
053600                    + TRANSF-XX * (ATAN-COEFF3                    93/08/20
053700                    + TRANSF-XX * (ATAN-COEFF5                    93/08/20
053800                    + TRANSF-XX * (ATAN-COEFF7                    93/08/20
053900                    + WORK-W))))                                  93/08/20
054000     COMPUTE ARCTAN-X = PI-QUARTER + WORK-X                       SOBEMAP.
054100     .                                                            SOBEMAP.
054200                                                                  87/05/30
054300*********************    ARCSIN FUNCTION    **********************SOBEMAP.
054400*                                                                *SOBEMAP.
054500*              COMPUTES RESULT = ARCSIN (ARGUMENT-1)             *SOBEMAP.
054600*                                                                *SOBEMAP.
054700*----------------------------------------------------------------*SOBEMAP.
054800                                                                  87/05/30
054900 ARCSINE-FUNCTION.                                                87/05/30
055000     MOVE MATHPK-ARGUMENT-1 TO ARG-X                              87/06/10
055100     IF ARG-X < ZERO                                              87/05/29
055200         MOVE "NEGATIVE" TO SIGN-OF-ARGUMENT                      87/05/29
055300         COMPUTE ARG-X = VALUE-ZERO - ARG-X                       90/09/20
055400     ELSE                                                         87/05/29
055500         MOVE "POSITIVE" TO SIGN-OF-ARGUMENT                      87/05/29
055600     .                                                            87/05/29
055700     IF ARG-X > VALUE-ONE                                         87/05/30
055800         PERFORM SET-DOMAIN-ERROR                                 87/05/30
055900     ELSE                                                         87/05/30
056000     IF ARG-X < +0.0001                                           87/05/30
056100         MOVE ARG-X TO ARCSIN-X                                   87/05/30
056200     ELSE                                                         87/05/30
056300         PERFORM COMPUTE-ARCSIN-APPROX                            87/05/30
056400     .                                                            87/05/30
056500     IF ARGUMENT-IS-NEGATIVE                                      87/05/30
056600         COMPUTE MATHPK-RESULT = VALUE-ZERO - ARCSIN-X            90/09/20
056700     ELSE                                                         87/05/30
056800         COMPUTE MATHPK-RESULT =   ARCSIN-X                       87/05/30
056900     .                                                            87/05/30
057000                                                                  87/06/10
057100 COMPUTE-ARCSIN-APPROX.                                           87/05/30
057200     MOVE ARG-X TO X1                                             87/05/30
057300     COMPUTE ARG-X = VALUE-ONE - ARG-X                            87/05/30
057400     PERFORM COMPUTE-SQRT-FUNCTION                                87/05/30
057500                                                                  87/05/30
057600     COMPUTE TRANSF--W =          (ARCSIN-COEFF3 + X1             93/08/20
057700                                * (ARCSIN-COEFF4 + X1             93/08/20
057800                                * (ARCSIN-COEFF5 + X1             93/08/20
057900                                * (ARCSIN-COEFF6 + X1             93/08/20
058000                                *  ARCSIN-COEFF7))))              93/08/20
058100     COMPUTE ARCSIN-X = PI-HALF - SQRT-X                          87/05/30
058200                                * (ARCSIN-COEFF0 + X1             87/05/30
058300                                * (ARCSIN-COEFF1 + X1             87/05/30
058400                                * (ARCSIN-COEFF2 + X1             87/05/30
058500                                *  TRANSF--W)))                   93/08/20
058600     .                                                            87/05/30
058700                                                                  87/06/10
058800*********************    COSINE FUNCTION    **********************SOBEMAP.
058900*                                                                *SOBEMAP.
059000*               COMPUTES RESULT = COS (ARGUMENT-1)               *SOBEMAP.
059100*                                                                *SOBEMAP.
059200*----------------------------------------------------------------*SOBEMAP.
059300                                                                  87/05/30
059400 COSINE-FUNCTION.                                                 87/05/30
059500     COMPUTE ARG-X = PI-HALF - MATHPK-ARGUMENT-1                  87/06/10
059600     PERFORM COMPUTE-SINE-FUNCTION                                87/05/30
059700     MOVE SINE-X TO MATHPK-RESULT                                 87/05/30
059800     .                                                            87/05/30
059900                                                                  87/05/30
060000**********************    SINE FUNCTION    ***********************SOBEMAP.
060100*                                                                *SOBEMAP.
060200*               COMPUTES RESULT = SIN (ARGUMENT-1)               *SOBEMAP.
060300*                                                                *SOBEMAP.
060400*----------------------------------------------------------------*SOBEMAP.
060500                                                                  87/05/29
060600 SINE-FUNCTION.                                                   87/05/29
060700     COMPUTE ARG-X = MATHPK-ARGUMENT-1                            87/05/30
060800     PERFORM COMPUTE-SINE-FUNCTION                                87/05/30
060900     MOVE SINE-X TO MATHPK-RESULT                                 87/05/30
061000     .                                                            87/05/30
061100                                                                  87/05/30
061200 COMPUTE-SINE-FUNCTION.                                           87/05/30
061300     IF ARG-X < ZERO                                              87/05/29
061400         MOVE "NEGATIVE" TO SIGN-OF-ARGUMENT                      87/05/29
061500         COMPUTE ARG-X = VALUE-ZERO - ARG-X                       90/09/20
061600     ELSE                                                         87/05/29
061700         MOVE "POSITIVE" TO SIGN-OF-ARGUMENT                      87/05/29
061800     .                                                            87/05/29
061900     IF ARG-X > TWO-PI                                            87/05/29
062000         PERFORM REDUCE-TO-WITHIN-TWO-PI                          87/05/29
062100     ELSE                                                         87/05/29
062200         MOVE ARG-X TO X1                                         87/05/29
062300     .                                                            87/05/29
062400     IF X1 > VALUE-PI                                             87/05/29
062500         SUBTRACT VALUE-PI FROM X1                                87/05/29
062600         MOVE "NEGATIVE" TO SIGN-OF-RESULT                        87/05/29
062700     ELSE                                                         87/05/29
062800         MOVE "POSITIVE" TO SIGN-OF-RESULT                        87/05/29
062900     .                                                            87/05/29
063000     IF X1 > PI-HALF                                              87/05/29
063100         COMPUTE X1 = VALUE-PI - X1                               87/05/29
063200     .                                                            87/05/29
063300     PERFORM COMPUTE-SINE-APPROX                                  87/05/29
063400                                                                  87/05/29
063500     IF RESULT-IS-NEGATIVE                                        87/05/29
063600         COMPUTE SINE-X = VALUE-ZERO - SINE-X                     90/09/20
063700     .                                                            87/05/29
063800     IF ARGUMENT-IS-NEGATIVE                                      87/05/29
063900         COMPUTE SINE-X = VALUE-ZERO - SINE-X                     90/09/20
064000     .                                                            87/05/29
064100                                                                  87/05/29
064200 REDUCE-TO-WITHIN-TWO-PI.                                         87/05/29
064300     COMPUTE NUMBER-OF-TURNS ROUNDED = ARG-X / TWO-PI             87/05/29
064400                                                                  87/05/29
064500     COMPUTE FRACTIONAL-TURN  = NUMBER-OF-TURNS - WHOLE-TURNS     87/05/29
064600     COMPUTE       X1         = FRACTIONAL-TURN * TWO-PI          87/05/29
064700     .                                                            87/05/29
064800                                                                  87/05/29
064900 COMPUTE-SINE-APPROX.                                             87/05/29
065000     IF X1 < +0.0001                                              87/05/30
065100         MOVE X1 TO SINE-X                                        87/05/30
065200     ELSE                                                         87/05/30
065300         COMPUTE X1 = X1 / PI-HALF                                87/05/29
065400         COMPUTE X2 = X1 * X1                                     87/05/29
065500         COMPUTE SINE-X = X1 * (SINE-COEFF1                       87/05/29
065600                        + X2 * (SINE-COEFF3                       87/05/29
065700                        + X2 * (SINE-COEFF5                       87/05/29
065800                        + X2 * (SINE-COEFF7                       87/05/29
065900                        + X2 *  SINE-COEFF9))))                   87/05/29
066000                                                                  87/06/10
066100         IF SINE-X > VALUE-ONE                                    87/05/29
066200             MOVE VALUE-ONE TO SINE-X                             87/05/29
066300     .                                                            87/05/29
066400                                                                  87/05/29
066500*******************   EXPONENTIAL FUNCTION    ********************SOBEMAP.
066600*                                                                *SOBEMAP.
066700*               COMPUTES RESULT = EXP (ARGUMENT-1)               *SOBEMAP.
066800*                                                                *SOBEMAP.
066900*----------------------------------------------------------------*SOBEMAP.
067000                                                                  SOBEMAP.
067100 EXPONENTIAL-FUNCTION.                                            87/05/30
067200     MOVE MATHPK-ARGUMENT-1 TO ARG-X                              87/05/30
067300     IF ARG-X < ZERO                                              87/05/30
067400         MOVE "NEGATIVE" TO SIGN-OF-ARGUMENT                      87/05/30
067500         IF ARG-X < -21.5                                         87/05/30
067600             MOVE ZEROES TO EXP-X                                 87/05/30
067700         ELSE                                                     87/05/30
067800             COMPUTE ARG-X = VALUE-ZERO - ARG-X                   90/09/20
067900             PERFORM COMPUTE-EXP-APPROX                           87/05/30
068000     ELSE                                                         87/05/30
068100     IF ARG-X > ZERO                                              87/05/30
068200         MOVE "POSITIVE" TO SIGN-OF-ARGUMENT                      87/05/30
068300         IF ARG-X > +20.6                                         87/05/30
068400             PERFORM SET-RANGE-ERROR                              87/05/30
068500         ELSE                                                     87/05/30
068600             PERFORM COMPUTE-EXP-APPROX                           87/05/30
068700     ELSE                                                         87/05/30
068800         MOVE VALUE-ONE TO EXP-X                                  87/05/30
068900     .                                                            87/05/30
069000     MOVE EXP-X TO MATHPK-RESULT                                  87/05/30
069100     .                                                            87/05/30
069200                                                                  87/05/30
069300 COMPUTE-EXP-APPROX.                                              87/05/30
069400     COMPUTE WORK-W =     ARG-X * (EXP-COEFF4                     93/08/20
069500                        + ARG-X * (EXP-COEFF5                     93/08/20
069600                        + ARG-X *  EXP-COEFF6))                   93/08/20
069700     COMPUTE ARG-X  = 1 + ARG-X * (EXP-COEFF1                     93/08/20
069800                        + ARG-X * (EXP-COEFF2                     93/08/20
069900                        + ARG-X * (EXP-COEFF3                     93/08/20
070000                        + WORK-W)))                               93/08/20
070100                                                                  87/06/10
070200     COMPUTE EXP-X = ARG-X * ARG-X                                87/05/30
070300     COMPUTE EXP-X = EXP-X * EXP-X                                87/05/30
070400                                                                  87/06/10
070500     IF ARGUMENT-IS-NEGATIVE                                      87/05/30
070600         COMPUTE EXP-X = VALUE-ONE / EXP-X                        87/05/30
070700     .                                                            87/05/30
070800                                                                  87/06/10
070900**********************   RANDOM FUNCTION    **********************SOBEMAP.
071000*                                                                *SOBEMAP.
071100*            COMPUTES RESULT = RANDOM FRACTION IN (0:1)          *SOBEMAP.
071200*                                                                *SOBEMAP.
071300*----------------------------------------------------------------*SOBEMAP.
071400                                                                  SOBEMAP.
071500 RANDOM-FUNCTION.                                                 87/06/10
071600     MOVE MATHPK-ARGUMENT-1 TO RANDOM-INTEGER                     87/11/17
071700                                                                  87/11/17
071800     COMPUTE RANDOM-PRODUCT  = RANDOM-INCREMENT                   87/06/10
071900                             + RANDOM-MULTIPLIER * RANDOM-INTEGER 87/06/10
072000     COMPUTE RANDOM-QUOTIENT = RANDOM-PRODUCT    / RANDOM-MODULUS 87/06/10
072100     COMPUTE RANDOM-INTEGER  = RANDOM-PRODUCT                     87/06/10
072200                             - RANDOM-QUOTIENT   * RANDOM-MODULUS 87/06/10
072300     COMPUTE MATHPK-RESULT   = RANDOM-INTEGER    / RANDOM-ADJUST  87/06/11
072400                                                                  87/11/17
072500     MOVE RANDOM-INTEGER TO MATHPK-ARGUMENT-1                     87/11/17
072600     .                                                            87/06/10
072700                                                                  87/06/10
072800*******************    SEED RANDOM FUNCTION    *******************SOBEMAP.
072900*                                                                *SOBEMAP.
073000*            SEEDS THE RANDOM NUMBER GENERATOR WITH THE          *SOBEMAP.
073100*            NUMBER IN ARGUMENT-1, WHICH MUST BE WITHIN          *SOBEMAP.
073200*                       THE INTERVAL (0:1)                       *SOBEMAP.
073300*                                                                *SOBEMAP.
073400*----------------------------------------------------------------*SOBEMAP.
073500                                                                  SOBEMAP.
073600 SEED-RANDOM-FUNCTION.                                            87/06/10
073700     MOVE MATHPK-ARGUMENT-1 TO ARG-X                              87/06/10
073800     IF ZERO < ARG-X                                              87/06/10
073900        AND    ARG-X < VALUE-ONE                                  87/06/10
074000         COMPUTE RANDOM-INTEGER = ARG-X * RANDOM-PRECISION        87/06/10
074100         MOVE RANDOM-INTEGER TO MATHPK-ARGUMENT-1                 87/11/17
074200     ELSE                                                         87/06/10
074300         PERFORM SET-DOMAIN-ERROR                                 87/06/10
074400     .                                                            87/06/10
074500                                                                  87/06/10
074600***********************    VALUE OF E    *************************SOBEMAP.
074700*                                                                *SOBEMAP.
074800*             RETURNS RESULT = VALUE OF E = 2.718...             *SOBEMAP.
074900*                                                                *SOBEMAP.
075000*----------------------------------------------------------------*SOBEMAP.
075100                                                                  SOBEMAP.
075200 RETURN-VALUE-OF-E.                                               SOBEMAP.
075300     MOVE VALUE-E TO MATHPK-RESULT                                87/06/10
075400     .                                                            87/06/10
075500                                                                  87/06/10
075600**********************    VALUE OF PI    *************************SOBEMAP.
075700*                                                                *SOBEMAP.
075800*            RETURNS RESULT = VALUE OF PI = 3.141...             *SOBEMAP.
075900*                                                                *SOBEMAP.
076000*----------------------------------------------------------------*SOBEMAP.
076100                                                                  SOBEMAP.
076200 RETURN-VALUE-OF-PI.                                              SOBEMAP.
076300     MOVE VALUE-PI TO MATHPK-RESULT                               87/06/10
076400     .                                                            87/06/10
076500                                                                  87/06/10
076600******************    VALUE OF GOLDEN RATIO    *******************SOBEMAP.
076700*                                                                *SOBEMAP.
076800*       RETURNS RESULT = VALUE OF GOLDEN RATIO = 1.618...        *SOBEMAP.
076900*                                                                *SOBEMAP.
077000*----------------------------------------------------------------*SOBEMAP.
077100                                                                  SOBEMAP.
077200 RETURN-VALUE-OF-GOLDEN-RATIO.                                    SOBEMAP.
077300     MOVE VALUE-GOLDEN-RATIO TO MATHPK-RESULT                     87/06/10
077400     .                                                            87/06/10